;#################AUTO_SAVE_V0.4#################
;# AUTHOR   - Glamorous Godfrey                 #
;# DATE     - 15/11/2017                        #
;# COMPILER - FASM                              #
;# OS       - KOLIBRIOS                         #
;################################################
;# USE: @AS <PATH> <TIMER>                      #
;################################################

use32
org 0x0
;=====================HEADER=====================
        db      'MENUET01'
        dd      0x01
        dd      start
        dd      i_end
        dd      mem
        dd      stacktop
        dd      param
        dd      0
;================================================
include 'macros.inc'
timer_mult = 60                             ;Для преобразования секунды в минуты
;======================CODE======================
start:
        mcall   40, 2                       ;Устанавливаем маску событий

        cmp     byte [param], 0             ;Проверяем наличие параметра
        jz      noparam1                    ;если нет,  то выводим сообщение и выходим

;================================================{

        mov     edi, param                  ;Подготавливаем первый параметр
        mov     al, ' '                     ;
        mov     ecx, 1024                   ;
        repne   scasb                       ;
        xor     eax, eax                    ;
        dec     edi                         ;
        stosb                               ;для использования в Rdsave

;================================================}

        cmp     byte [edi], 0               ;Проверяем наличие второго параметра
        jz      noparam2                    ;если нет,  то выводим сообщение и выходим

        cmp     byte [edi+2], 0             ;Проверяем на превышение лимита
        jnz     max                         ;если лимит превышен выводим сообщение и выходим

;================================================{

        mov     esi, edi                    ;Получаем
        xor     eax, eax                    ;количество
        mov     ecx, 3                      ;символов
        repne   scasb                       ;второго
        sub     edi, esi                    ;параметра
        dec     edi                         ;

;================================================}

;================================================{
@@:                                         ;Преобразовываем
        dec     edi                         ;второй
        jz      @f                          ;
        lodsb                               ;
        sub     eax, 0x30                   ;
        add     edx, eax                    ;параметр
        shl     edx, 3                      ;
        shl     eax, 1                      ;
        add     edx, eax                    ;
        dec     edi                         ;из символов
        jmp     @b                          ;
@@:                                         ;
        lodsb                               ;
        sub     eax, 0x30                   ;
        add     edx, eax                    ;
        mov     [timer], edx                ;в десятичное число

;================================================}
        mcall   66, 4, 195, 0x110           ;Устанавливаем
        inc     ecx                         ;
        mcall   66, , ,                     ;
        mcall   66, , 187,                  ;
        inc     ecx                         ;
        mcall   66, , ,                     ;
        inc     ecx                         ;
        mcall   66, , ,                     ;"горячие клавиши"

        mov     [message], messages.info    ;Выводим
        mcall   70, file_open               ;сообщение

        mov     [message], messages.on      ;Выводим
        mcall   70,

        mov     eax, [timer]                ;Переводим
        mov     ebx, timer_mult             ;
        mul     ebx                         ;
        mov     [timer], eax                ;секунды в мин

;================================================{
check:
        mcall   18, 6, param                ;сохраняем образ
        test    eax, eax                    ;если не 0, то ошибка
        jnz     error
        mov     [message], messages.ok
        mcall   70, file_open
        mov     ecx, [timer]                ;счетчик
@@:
        test    ecx, ecx                    ;если счетчик = 0 то
        jz      check                       ;
        dec     ecx                         ;уменьшаем счетчик
        mcall   5, 100                      ;задержка
        mcall   2                           ;получаем сканкод клавиши
        dec     al                          ;сравниваем al с 0
        jz      @b                          ;
        cmp     ah, 195                     ;сравниваем сканкод нажатой клавиши с F9
        je      check                       ;
        cmp     ah, 196                     ;сравниваем сканкод нажатой клавиши с F10
        je      off                         ;
        mov     ecx, 4                      ;
        mov     ebx, 9                      ;
        sub     ah, 189                     ;
        jz      crs                         ;
        dec     ecx                         ;
        inc     ah                          ;
        jz      crs                         ;
        dec     ecx                         ;

;================================================}
;================================================
crs:
        mcall   18, ,                       ;Shutdown/Restart/Restart core в зависимости от значения в ebx

;================================================
noparam1:
        mov     [message], messages.noparam1
        jmp     exit
noparam2:
        mov     [message], messages.noparam2
        jmp     exit
max:
        mov     [message], messages.max
        jmp     exit
off:
        mov     [message], messages.off
        jmp     exit
error:
        mov     [message], messages.error
        jmp     exit

;================================================
exit:
        mcall   70, file_open
        mcall   -1

i_end:
;======================DATA======================

file_open:
                dd 7
                dd 0
message         dd 0
                dd 0
                dd 0
                db '/sys/@notify', 0

;================================================
messages:
.on             db '"@AS: ON"-O', 0
.off            db '"@AS: OFF"-O', 0
.ok             db '"@AS: Save done!"-O', 0
.noparam1       db '"@AS: No set path!"-E', 0
.noparam2       db '"@AS: No set timer!"-E', 0
.max            db '"@AS: Timer limit(1-99)!"-E', 0
.error          db '"@AS: ERROR!"-E', 0
.info           db '"@AS: HOTKEYS'
                db '\n#=================#'
                db '\nCtrl+Alt+F1  - Shutdown PC'
                db '\nCtrl+Alt+F2  - Restart  PC'
                db '\nCtrl+Alt+F3  - Restart core'
                db '\nCtrl+Alt+F9  - Save'
                db '\nCtrl+Alt+F10 - OFF'
                db '\n#=================#"-I', 0
;================================================

timer           rd 1
param           rb 1025

mem:
;================================================
                rb 512
stacktop:
;================================================
